PSingleMonitoredSocket Class Reference

This concrete class monitors a single scoket bound to a specific interface or address. More...

`#include <psockbun.h>`

Inheritance diagram for PSingleMonitoredSocket:

## Public Member Functions

| PSingleMonitoredSocket (const PString &theInterface, bool reuseAddr=false, PNatMethod *natMethod=NULL)
| ~PSingleMonitoredSocket ()
virtual PStringArray | GetInterfaces (bool includeLoopBack=false, const PIPSocket::Address &destination=PIPSocket::GetDefaultIpAny())
| Get an array of all current interface descriptors, possibly including the loopback (127.0.0.1) interface. More...
virtual PBoolean | Open (WORD port)
| Open the socket(s) using the specified port. More...
virtual PBoolean | Close ()
| Close all socket(s) More...
virtual PBoolean | GetAddress (const PString &iface, PIPSocket::Address &address, WORD &port, PBoolean usingNAT) const
| Get the local address for the given interface. More...
virtual PChannel::Errors | WriteToBundle (const void *buf, PINDEX len, const PIPSocket::Address &addr, WORD port, const PString &iface, PINDEX &lastWriteCount)
| Write to the remote address/port using the socket(s) available. More...
virtual PChannel::Errors | ReadFromBundle (void *buf, PINDEX len, PIPSocket::Address &addr, WORD &port, PString &iface, PINDEX &lastReadCount, const PTimeInterval &timeout)
| Read fram a remote address/port using the socket(s) available. More...
Public Member Functions inherited from PMonitoredSockets
PBoolean | IsOpen () const
| Indicate if the socket(s) are open and ready for reads/writes. More...
WORD | GetPort () const
| Return the local port number being used by the socket(s) More...
void | SetNatMethod (PNatMethod *method)
| Set the NAT method, eg STUN client pointer. More...
PNatMethod * | GetNatMethod () const
Public Member Functions inherited from PInterfaceMonitorClient
| PInterfaceMonitorClient (PINDEX priority=DefaultPriority)
| ~PInterfaceMonitorClient ()
virtual PBoolean | GetInterfaceInfo (const PString &iface, InterfaceEntry &info) const
| Return information about an active interface given the descriptor string. More...
PINDEX | GetPriority () const
| Returns the priority of this client. More...
Public Member Functions inherited from PSafeObject
| PSafeObject (PSafeObject *indirectLock=NULL)
| Create a thread safe object. More...
PBoolean | SafeReference ()
| Increment the reference count for object. More...
PBoolean | SafeDereference ()
| Decrement the reference count for object. More...
PBoolean | LockReadOnly () const
| Lock the object for Read Only access. More...
void | UnlockReadOnly () const
| Release the read only lock on an object. More...
PBoolean | LockReadWrite ()
| Lock the object for Read/Write access. More...
void | UnlockReadWrite ()
| Release the read/write lock on an object. More...
void | SafeRemove ()
| Set the removed flag. More...
PBoolean | SafelyCanBeDeleted () const
| Determine if the object can be safely deleted. More...
virtual bool | GarbageCollection ()
| Do any garbage collection that may be required by the object so that it may be finally deleted. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

virtual void | OnAddInterface (const InterfaceEntry &entry)
| Call back function for when an interface has been added to the system. More...
virtual void | OnRemoveInterface (const InterfaceEntry &entry)
| Call back function for when an interface has been removed from the system. More...
bool | IsInterface (const PString &iface) const
Protected Member Functions inherited from PMonitoredSockets
| PMonitoredSockets (bool reuseAddr, PNatMethod *natMethod)
virtual void | OnRemoveNatMethod (const PNatMethod *natMethod)
| Called when a NAT method is about to be destroyed. More...
bool | CreateSocket (SocketInfo &info, const PIPSocket::Address &binding)
bool | DestroySocket (SocketInfo &info)
bool | GetSocketAddress (const SocketInfo &info, PIPSocket::Address &address, WORD &port, bool usingNAT) const
PChannel::Errors | WriteToSocket (const void *buf, PINDEX len, const PIPSocket::Address &addr, WORD port, const SocketInfo &info, PINDEX &lastWriteCount)
PChannel::Errors | ReadFromSocket (SocketInfo &info, void *buf, PINDEX len, PIPSocket::Address &addr, WORD &port, PINDEX &lastReadCount, const PTimeInterval &timeout)
PChannel::Errors | ReadFromSocket (PSocket::SelectList &readers, PUDPSocket *&socket, void *buf, PINDEX len, PIPSocket::Address &addr, WORD &port, PINDEX &lastReadCount, const PTimeInterval &timeout)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PString | theInterface
InterfaceEntry | theEntry
SocketInfo | theInfo
Protected Attributes inherited from PMonitoredSockets
WORD | localPort
bool | reuseAddress
PNatMethod * | natMethod
bool | opened
PUDPSocket | interfaceAddedSignal
Protected Attributes inherited from PInterfaceMonitorClient
PINDEX | priority

## Additional Inherited Members

Public Types inherited from PInterfaceMonitorClient
enum | { DefaultPriority = 50 }
typedef PIPSocket::InterfaceEntry | InterfaceEntry
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PMonitoredSockets
static PMonitoredSockets * | Create (const PString &iface, bool reuseAddr=false, PNatMethod *natMethod=NULL)
| Create a new monitored socket instance based on the interface descriptor. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Detailed Description

This concrete class monitors a single scoket bound to a specific interface or address.

The interface name may be a partial descriptor such as "%eth0".

## Constructor & Destructor Documentation

## PSingleMonitoredSocket()

PSingleMonitoredSocket::PSingleMonitoredSocket | ( | const PString & | theInterface,
|  | bool | reuseAddr = `false`,
|  | PNatMethod * | natMethod = `NULL`
| ) |  |

## ~PSingleMonitoredSocket()

PSingleMonitoredSocket::~PSingleMonitoredSocket | ( |  | ) |

## Member Function Documentation

## Close()

virtual PBoolean PSingleMonitoredSocket::Close | ( |  | ) |

virtual

Close all socket(s)

Implements PMonitoredSockets.

## GetAddress()

virtual PBoolean PSingleMonitoredSocket::GetAddress | ( | const PString & | iface,
|  | PIPSocket::Address & | address,
|  | WORD & | port,
|  | PBoolean | usingNAT
| ) |  | const

virtual

Get the local address for the given interface.

Parameters

  iface | Interface to get address for
  address | Address of interface
  port | Port listening on
  usingNAT | Require NAT address/port

Implements PMonitoredSockets.

## GetInterfaces()

virtual PStringArray PSingleMonitoredSocket::GetInterfaces | ( | bool | includeLoopBack = `false`,
|  | const PIPSocket::Address & | destination = `PIPSocket::GetDefaultIpAny()`
| ) |  |

virtual

Get an array of all current interface descriptors, possibly including the loopback (127.0.0.1) interface.

Note the names are of the form ipname, eg "10.0.1.11%3Com 3C90x Ethernet Adapter" or "192.168.0.10%eth0"

Parameters

  includeLoopBack | Flag for if loopback is to included in list
  destination | Optional destination for selecting specific interface

Reimplemented from PInterfaceMonitorClient.

## IsInterface()

bool PSingleMonitoredSocket::IsInterface | ( | const PString & | iface | ) | const

protected

## OnAddInterface()

virtual void PSingleMonitoredSocket::OnAddInterface | ( | const InterfaceEntry & | entry | ) |

protected virtual

Call back function for when an interface has been added to the system.

Implements PInterfaceMonitorClient.

## OnRemoveInterface()

virtual void PSingleMonitoredSocket::OnRemoveInterface | ( | const InterfaceEntry & | entry | ) |

protected virtual

Call back function for when an interface has been removed from the system.

Implements PInterfaceMonitorClient.

## Open()

virtual PBoolean PSingleMonitoredSocket::Open | ( | WORD | port | ) |

virtual

Open the socket(s) using the specified port.

If port is zero then a system allocated port is used. In this case and when multiple interfaces are supported, all sockets use the same dynamic port value.

Returns true if all sockets are opened.

Implements PMonitoredSockets.

## ReadFromBundle()

virtual PChannel::Errors PSingleMonitoredSocket::ReadFromBundle | ( | void * | buf,
|  | PINDEX | len,
|  | PIPSocket::Address & | addr,
|  | WORD & | port,
|  | PString & | iface,
|  | PINDEX & | lastReadCount,
|  | const PTimeInterval & | timeout
| ) |  |

virtual

Read fram a remote address/port using the socket(s) available.

If the iface parameter is empty, then the first data received on any socket(s) is used, and the iface parameter is set to the name of that interface. Otherwise the iface parameter indicates the specific interface socket to read the data from.

Implements PMonitoredSockets.

## WriteToBundle()

virtual PChannel::Errors PSingleMonitoredSocket::WriteToBundle | ( | const void * | buf,
|  | PINDEX | len,
|  | const PIPSocket::Address & | addr,
|  | WORD | port,
|  | const PString & | iface,
|  | PINDEX & | lastWriteCount
| ) |  |

virtual

Write to the remote address/port using the socket(s) available.

If the iface parameter is empty, then the data is written to all socket(s). Otherwise the iface parameter indicates the specific interface socket to write the data to.

Implements PMonitoredSockets.

## Member Data Documentation

## theEntry

InterfaceEntry PSingleMonitoredSocket::theEntry

protected

## theInfo

SocketInfo PSingleMonitoredSocket::theInfo

protected

## theInterface

PString PSingleMonitoredSocket::theInterface

protected

The documentation for this class was generated from the following file:

- psockbun.h